本文最后编辑于 前,其中的内容可能需要更新。
题目描述:
给你一个整数数组 nums
和一个整数 k
,请你返回其中出现频率前 k
高的元素。你可以按 任意顺序 返回答案。
进阶:你所设计算法的时间复杂度 必须 优于 O(n log n)
,其中 n
是数组大小。
示例 1:
1 2
| 输入: nums = [1,1,1,2,2,3], k = 2 输出: [1,2]
|
示例 2:
1 2
| 输入: nums = [1], k = 1 输出: [1]
|
提示:
- $1 <= nums.length <= 10^5$
k
的取值范围是 [1, 数组中不相同的元素的个数]
- 题目数据保证答案唯一,换句话说,数组中前
k
个高频元素的集合是唯一的
链接:
https://leetcode-cn.com/problems/top-k-frequent-elements
题目分析
这道题也是一道 Top-K 问题,不同之处在于我们还需要统计每个数字出现的次数。这里我们使用一个哈希表统计每个数字出现的次数。之后再使用 Leetcode 215.数组中的第K个最大元素 同样的做法得到出现前 k
多的元素即可。
稍微有点不同的是,这里我们统计的是出现的次数,没办法在原数组进行操作,所以只能首先将前 k
个数加入到数字中,建立一个堆。并且我们要比较的是数字出现的次数,而最后记录的结果是数字本身,因此哈希表也要传入函数中作为比较依据,而存入堆数组的就是数字本身。
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43
| class Solution { void adjustHeap(vector<int>& heap, int begin, unordered_map<int, int>& times, int k){ while(2 * begin + 1 < k){ int minChild = 2 * begin + 1; if(minChild + 1 < k && times[heap[minChild + 1]] < times[heap[minChild]]){ minChild++; } if(times[heap[minChild]] < times[heap[begin]]){ swap(heap[minChild], heap[begin]); begin = minChild; } else break; } } public: vector<int> topKFrequent(vector<int>& nums, int k) { unordered_map<int, int> times; for(const int& num : nums){ times[num]++; } vector<int> result; int count = 0; for(auto it : times){ if(count < k){ result.emplace_back(it.first); count++; if(count == k){ for(int begin = k / 2 - 1; begin >= 0; begin--){ adjustHeap(result, begin, times, k); } } } else{ if(times[result[0]] < it.second){ result[0] = it.first; adjustHeap(result, 0, times, k); } } } return result; } };
|
时间复杂度:$O(n\log k)$,其中 $n、k$ 分别是数组的大小和题目中的 k。建立哈希表需要遍历一次数组,所花时间 $O(n)$。遍历数组并加入堆调整堆的时间复杂度为 $O(n\log k)$。
空间复杂度:$O(n)$,其中 $n$ 是数组的大小。哈希表的大小就是数组中不同元素的种类,不会超过数组大小,为 $O(n)$,而堆的大小为 k,也是不超过数组大小,并且作为返回结果应该可以不计入空间复杂度。